/*
 *  exo11.c
 *  test palindrome
 */

#include <stdio.h>

#define MAX 500

/*
 * fonction qui renvoie la longueur d'une chaîne *
 * name: length
 * @chaine: pointeur à le première caractère d'une chaîne
 * @return: la longueur de la chaîne
 */
unsigned int length(char chaine[]) {
  unsigned int i;
  for(i = 0; chaine[i]; i++); // for qui ne fait rien, juste
                                      // incrémenter i 
  return i;
}
/*
 * attention, la fonction ci-dessu est presentée pour des raisons
 * didactiques. En general la librerie string.h contient assez de
 * fonctions sur les chaînes
 */

int palindrome(char chaine[], unsigned int length) {
  unsigned int i;
  for(i = 0; i<length/2; i++) {
    if(chaine[i] != chaine[length-i-1]) return 0;
  }
  return 1;
}

int main() {
  char in[MAX];
  printf("Bonjour !\n");
  printf("Svp, tapez une chaîne : ");
  scanf("%s", in);  // pas de &, parce que c'est un tableau, donc
                    // c'est déjà un pointeur
                    // %s c'est la chaîne de format pour les chaînes
                    // attention, la lecture d'une chaîne termine
                    // au premier espace ou caractére de nouvelle
                    // ligne
  if(palindrome(in,length(in))) printf("La chaîne est un palindrome\n");
  else printf("La chaine n'est pas un palindrome\n");
  printf("Au revoir !\n");
}
