/*
 *  exo03.c
 *  nombre de Fibonacci
 */

#include <stdio.h>

/*
 * calcul d'un nombre de Fibonacci
 * name: fibo
 * @n :       un nombre entier, @n >= 0
 * @return :  l'@n-ème nombre de Fibonacci
 */
int fibo(int n) {
  if (n <= 1) return 1;
  int i;
  int app;  // variable d'appui
  int fimoins1; // le nombre de Fibonacci précedent
  int fi;       // le nombre de Fibonacci actuel
  fimoins1 = 1;
  fi = 1;
  for (i = 2; i <= n; i++) {
    app = fimoins1;
    fimoins1 = fi;
    fi += app;  // fi contient les valeurs de fimoins1+fi au debut du cycle
  }
  return fi;
}

int main() {
  int x;
  printf("Bonjour !\n");
  printf("Svp, tapez un entier : ");
  scanf("%d",&x);
  printf("Le %de nombre de Fibonacci est %d.\n", x, fibo(x));
}

/* autre possibilité : initialiser x à un nombre different de 0
 * et utiliser
 *    while(n != 0) {
 *      ...
 *    }
 *  mais cela utilise un condition en plus. En general, on
 *  utilise do { ... } while(cond) si on doit faire le cycle
 *  au moins une fois.
 */
